// Code generated by Wire. DO NOT EDIT.

//go:generate go run github.com/google/wire/cmd/wire
//go:build !wireinject
// +build !wireinject

package app

import (
	"github.com/aserto-dev/clui"
	"github.com/google/wire"
	"github.com/opcr-io/policy/pkg/cc"
	"github.com/opcr-io/policy/pkg/cc/config"
	"io"
)

// Injectors from wire.go:

func BuildPolicyApp(logWriter io.Writer, configPath config.Path, overrides config.Overrider) (*PolicyApp, func(), error) {
	ccCC, cleanup, err := cc.NewCC(logWriter, configPath, overrides)
	if err != nil {
		return nil, nil, err
	}
	context := ccCC.Context
	cancelFunc := ccCC.CancelFunc
	logger := ccCC.Log
	configConfig := ccCC.Config
	ui := clui.NewUI()
	policyApp := &PolicyApp{
		Context:       context,
		Cancel:        cancelFunc,
		Logger:        logger,
		Configuration: configConfig,
		UI:            ui,
	}
	return policyApp, func() {
		cleanup()
	}, nil
}

func BuildTestPolicyApp(logWriter io.Writer, configPath config.Path, overrides config.Overrider) (*PolicyApp, func(), error) {
	ccCC, cleanup, err := cc.NewTestCC(logWriter, configPath, overrides)
	if err != nil {
		return nil, nil, err
	}
	context := ccCC.Context
	cancelFunc := ccCC.CancelFunc
	logger := ccCC.Log
	configConfig := ccCC.Config
	ui := clui.NewUI()
	policyApp := &PolicyApp{
		Context:       context,
		Cancel:        cancelFunc,
		Logger:        logger,
		Configuration: configConfig,
		UI:            ui,
	}
	return policyApp, func() {
		cleanup()
	}, nil
}

// wire.go:

var (
	policyAppSet = wire.NewSet(cc.NewCC, clui.NewUI, wire.FieldsOf(new(*cc.CC), "Config", "Log", "Context", "ErrGroup", "CancelFunc"))

	policyAppTestSet = wire.NewSet(cc.NewTestCC, clui.NewUI, wire.FieldsOf(new(*cc.CC), "Config", "Log", "Context", "ErrGroup", "CancelFunc"))
)
